package tictactoe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.LineBorder;


public class TicTacToeClient extends JApplet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	// Indicate whether the player has the turn
	private boolean turn = false;

	// Indicate the token for the player
	private char myToken = ' ';

	// Indicate the token for the other player
	private char otherToken = ' ';

	// Create and initialize cells
	private Cell[][] cell = new Cell[3][3];

	// Create and initialize a title label
	private JLabel jlblTitle = new JLabel();

	// Create and initialize a status label
	private JLabel jlblStatus = new JLabel();

	// Indicate selected row and column by the current move
	private int rowSelected;
	private int columnSelected;

	// Continue to play?
	private boolean continueToPlay = true;

	private TicTacToeImpl tictactoe;

	/** Initialize UI */
	public void init() {
		// Panel p to hold cells
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(3, 3, 0, 0));
		for (int i = 0; i < 3; i++)
			for (int j = 0; j < 3; j++)
				p.add(cell[i][j] = new Cell(i, j));

		// Set properties for labels and borders for labels and panel
		p.setBorder(new LineBorder(Color.black, 1));
		jlblTitle.setHorizontalAlignment(JLabel.CENTER);
		jlblTitle.setFont(new Font("SansSerif", Font.BOLD, 16));
		jlblTitle.setBorder(new LineBorder(Color.black, 1));
		jlblStatus.setBorder(new LineBorder(Color.black, 1));

		// Place the panel and the labels to the applet
		add(jlblTitle, BorderLayout.NORTH);
		add(p, BorderLayout.CENTER);
		add(jlblStatus, BorderLayout.SOUTH);
		// Create the tic tac toe core functions and rules
		tictactoe = new TicTacToeImpl();
	}

	public void play() {

		/*
		 * TODO: Fill the function. Play function should coordinate the turn,
		 * check if a player wins and if the game is a draw
		 */

	}

	// An inner class for a cell
	public class Cell extends JPanel {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		// Indicate the row and column of this cell in the board
		private int row;
		private int column;

		// Token used for this cell
		private char token = ' ';

		public Cell(int row, int column) {
			/*
			 * TODO: Initialize variables.You should initialize the variables
			 */
			this.setBorder(new LineBorder(Color.black, 1)); // Set cell's border
			this.addMouseListener(new ClickListener()); // Register listener

		}

		/** Return token */
		public char getToken() {
			return token;
		}

		/** Set a new token */
		public void setToken(char c) {
			token = c;
			repaint();
		}

		/** Paint the cell */
		protected void paintComponent(Graphics g) {
			super.paintComponent(g);
			if (token == 'X') {
				g.drawLine(10, 10, getWidth() - 10, getHeight() - 10);
				g.drawLine(getWidth() - 10, 10, 10, getHeight() - 10);
			} else if (token == 'O') {
				g.drawOval(10, 10, getWidth() - 20, getHeight() - 20);
			}
		}

		/** Handle mouse click on a cell */
		private class ClickListener extends MouseAdapter {
			public void mouseClicked(MouseEvent e) {
				// If cell is not occupied and the player has the turn
				if ((token == ' ') && continueToPlay) {
					setToken(myToken); // Set the player's token in the cell
					rowSelected = row;
					columnSelected = column;

					jlblStatus.setText("Waiting for the other player to move");
					/*
					 * TODO: Fill the function. Mark the specific cell with a specific token
					 */
					/*
					 * TODO: Every click should trigger a new turn (play function)
					 */
				}
			}
		}
	}

	/** This main method enables the applet to play as an application */
	public static void main(String[] args) {
		// Create a frame
		JFrame frame = new JFrame("Tic Tac Toe Client");

		// Create an instance of the applet
		TicTacToeClient applet = new TicTacToeClient();

		// Add the applet instance to the frame
		frame.getContentPane().add(applet, BorderLayout.CENTER);

		// Invoke init() and start()
		applet.init();
		applet.start();
		
		/*
		 * TODO: Player 1 should start the game
		 */
		
		// Display the frame
		frame.setSize(320, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
	}
}